// SEND/DO SCRIPTS
//
//

// writes argument0 (Player) grabbed argument1 (Player) into argument2 (buffer)
sendGrab = '
	write_ubyte(argument2, carriers.GRAB);
	write_ubyte(argument2, ds_list_find_index(global.players, argument0));
	write_ubyte(argument2, ds_list_find_index(global.players, argument1));
';

// makes arg0.object grab arg1.object
// argument0: the grabbing Player
// argument1: the grabbed Player
doGrab = '
	var sending, grabbed;
	sending = argument0;
	grabbed = argument1;
	if(sending.object != -1) {
		if(sending.object.carry != noone) {
			execute_string(carriers.doRelease, sending, sending.object.carry);
		}
		sending.object.carry = grabbed.object;
		grabbed.object.carrier = sending.object;
		if(sending.class == CLASS_SPY) {
			with(sending.object.currentWeapon) {
				readyToStab = false;
				alarm[2] = StabreloadTime / global.delta_factor;
			}
		}
		if(sending == global.myself) {
			execute_string(carriers.showNotification, "You are carrying someone!#Press " + execute_string(carriers.getKeyStr, carriers.modeKey) + " to hide your weapon and run faster");
		}
		if(grabbed == global.myself) {
			execute_string(carriers.showNotification, "You are being carried!#Press " + execute_string(carriers.getKeyStr, carriers.grabKey) + " to free yourself");
		}
	}
';

// writes argument0 (Player) releases/is released into argument1 (buffer)
sendRelease = '
	write_ubyte(argument1, carriers.RELEASE);
	write_ubyte(argument1, ds_list_find_index(global.players, argument0));
';

doRelease = '
	var sending, releasedChar, carryingChar;
	sending = argument0;
	releasedChar = noone;
	carryingChar = noone;
	if(sending != noone)
	if(sending.object != -1) {
	
		carryingChar = execute_string(carriers.getStackBottom, sending.object);
		
		// if sender is carrying
		if(sending.object.carry != noone) {
			releasedChar = sending.object.carry;
			
			releasedChar.x = carryingChar.x;
			if(sending.class == CLASS_QUOTE) {
				releasedChar.y = carryingChar.y - 18;
			} else {
				releasedChar.y = carryingChar.y;
			}
			
			// dont stick people in walls goddammitasdfasdf
			with(releasedChar) {
				var stuck;
				stuck = true;
				if(collision_rectangle(bbox_left, bbox_top, bbox_right, bbox_bottom, Obstacle, true, false) <= 0)
				if(collision_rectangle(bbox_left, bbox_top, bbox_right, bbox_bottom, Gate, true, false) <= 0)
				if(collision_rectangle(bbox_left, bbox_top, bbox_right, bbox_bottom, PlayerWall, true, false) <= 0)
					stuck = false;
				if(stuck) {
					releasedChar.x = carryingChar.x;
					releasedChar.y = carryingChar.y;
				}
			}
			
			sending.object.carry.carrier = noone;
			sending.object.carry = noone;
		}
		// if sender is carried
		if(sending.object.carrier != noone) {
			releasedChar = sending.object;
			
			releasedChar.x = carryingChar.x;
			if(carryingChar.player.class == CLASS_QUOTE) {
				releasedChar.y = carryingChar.y - 18;
			} else {
				releasedChar.y = carryingChar.y;
			}
			
			// dont stick people in walls goddammitasdfasdf
			with(releasedChar) {
				var stuck;
				stuck = true;
				if(collision_rectangle(bbox_left, bbox_top, bbox_right, bbox_bottom, Obstacle, true, false) <= 0)
				if(collision_rectangle(bbox_left, bbox_top, bbox_right, bbox_bottom, Gate, true, false) <= 0)
				if(collision_rectangle(bbox_left, bbox_top, bbox_right, bbox_bottom, PlayerWall, true, false) <= 0)
					stuck = false;
				if(stuck) {
					releasedChar.x = carryingChar.x;
					releasedChar.y = carryingChar.y;
				}
			}
			
			sending.object.carrier.carry = noone;
			sending.object.carrier = noone;
		}
	}
	
';

inputForbid = '
	write_ubyte(argument1, carriers.FORBID);
	write_ubyte(argument1, ds_list_find_index(global.players, argument0));
';
sendForbid = '
	write_ubyte(argument2, carriers.FORBID);
	write_ubyte(argument2, ds_list_find_index(global.players, argument0));
	write_ubyte(argument2, ds_list_find_index(global.players, argument1));
';
doForbid = '
	ds_list_add(argument0.forbiddenCarriers, argument1);
	if(argument0 == global.myself) {
		with(NoticeO) instance_destroy();
		with(instance_create(0,0,NoticeO)) {
			notice = NOTICE_CUSTOM;
			message = argument1.name + " is no longer allowed to carry you!";
		}
	}
	if(argument1 == global.myself) {
		with(NoticeO) instance_destroy();
		with(instance_create(0,0,NoticeO)) {
			notice = NOTICE_CUSTOM;
			message = "You are no longer allowed to carry " + argument0.name + "!";
		}
	}
';

inputAllow = '
	write_ubyte(argument1, carriers.ALLOW);
	write_ubyte(argument1, ds_list_find_index(global.players, argument0));
';
sendAllow = '
	write_ubyte(argument2, carriers.ALLOW);
	write_ubyte(argument2, ds_list_find_index(global.players, argument0));
	write_ubyte(argument2, ds_list_find_index(global.players, argument1));
';
doAllow = '
	var index;
	index = ds_list_find_index(argument0.forbiddenCarriers, argument1);
	if(index > -1) {
		ds_list_delete(argument0.forbiddenCarriers, index);
		if(argument0 == global.myself) {
			with(NoticeO) instance_destroy();
			with(instance_create(0,0,NoticeO)) {
				notice = NOTICE_CUSTOM;
				message = argument1.name + " is allowed to carry you again!";
			}
		}
		if(argument1 == global.myself) {
			with(NoticeO) instance_destroy();
			with(instance_create(0,0,NoticeO)) {
				notice = NOTICE_CUSTOM;
				message = "You are allowed to carry " + argument0.name + " again!";
			}
		}
	} else {
		if(argument0 == global.myself) {
			with(NoticeO) instance_destroy();
			with(instance_create(0,0,NoticeO)) {
				notice = NOTICE_CUSTOM;
				message = argument1.name + " is already allowed to carry you!";
			}
		}
	}
';

sendBan = '
	write_ubyte(argument1, carriers.BAN);
	write_ubyte(argument1, ds_list_find_index(global.players, argument0));
';
doBan = '
	argument0.carryForbidden = true;
	if(argument0 == global.myself) {
		with(NoticeO) instance_destroy();
		with(instance_create(0,0,NoticeO)) {
			notice = NOTICE_CUSTOM;
			message = "You are no longer allowed to carry anyone!";
		}
	} else {
		with(NoticeO) instance_destroy();
		with(instance_create(0,0,NoticeO)) {
			notice = NOTICE_CUSTOM;
			message = argument0.name + " is no longer allowed to carry anyone!";
		}
	}
';

sendUnban = '
	write_ubyte(argument1, carriers.UNBAN);
	write_ubyte(argument1, ds_list_find_index(global.players, argument0));
';
doUnban = '
	argument0.carryForbidden = false;
	if(argument0 == global.myself) {
		with(NoticeO) instance_destroy();
		with(instance_create(0,0,NoticeO)) {
			notice = NOTICE_CUSTOM;
			message = "You are allowed to carry anyone again!";
		}
	} else {
		with(NoticeO) instance_destroy();
		with(instance_create(0,0,NoticeO)) {
			notice = NOTICE_CUSTOM;
			message = argument0.name + " is allowed to carry anyone again!";
		}
	}
';


// writes byte argument0 from player argument1 into argument2
sendByteFrom = '
	write_ubyte(argument2, argument0);
	write_ubyte(argument2, ds_list_find_index(global.players, argument1));
';