// MENUS
//
//
OptionMenu = object_add();
object_set_parent(OptionMenu,MenuController);  
object_set_depth(OptionMenu,-130000); 
object_event_add(OptionMenu,ev_create,0,'   
	menu_create(48, 172, 500, 260, 32, 40, 104, 6);
	menumode = true;
	
	if room != Options {
		menu_setdimmed();
	}
	
	menu_background(512, 24, 8, 12, 4);
    bgtabs = false;
	
	menu_addedit_boolean("Allow carrying", "carriers.carryEnable", "
        return argument0;
    ");
	
	menu_addedit_key("Grab Key", "carriers.grabKey");
	menu_addlink("The key used to carry/jump on the back of a teammate", "");
	
	menu_addedit_key("Run/Shoot Key", "carriers.modeKey");
	menu_addlink("When carrying someone, use this key to run faster/use your weapon", "");
	
	
	if(ds_list_size(global.players) > 1) {
	
		if(global.isHost) {
			selectedPlayer = ds_list_find_value(global.players, 1);
		} else {
			selectedPlayer = ds_list_find_value(global.players, 0);
		}
	
		// PLAYER SELECTION
		var i, p;
		menu_addedit_select("Select player:", "selectedPlayer", "return argument0;");
		for(i = 0; i < ds_list_size(global.players); i+=1) {
			p = ds_list_find_value(global.players, i);
			if(p != global.myself) {
				menu_add_option(p, p.name + ", " + execute_string(carriers.getTeamName, p.team) + ", " + execute_string(carriers.getClassName, p.class));
			}
		}
		
		// FORBID
		menu_addlink("FORBID  - Prevent this player from carrying you", "
			if(global.isHost) {
				execute_string(carriers.sendForbid, global.myself, selectedPlayer, carriers.NetworkController.sendBuffer);
				execute_string(carriers.doForbid, global.myself, selectedPlayer);
			} else {
				execute_string(carriers.inputForbid, selectedPlayer, carriers.NetworkController.sendBuffer);
			}
		");
		
		// ALLOW
		menu_addlink("ALLOW   - Allow this player to carry you", "
			if(global.isHost) {
				execute_string(carriers.sendAllow, global.myself, selectedPlayer, carriers.NetworkController.sendBuffer);
				execute_string(carriers.doAllow, global.myself, selectedPlayer);
			} else {
				execute_string(carriers.inputAllow, selectedPlayer, carriers.NetworkController.sendBuffer);
			}
		");
		
		// BAN
		if(global.isHost) {
			menu_addlink("BAN     - HOST -- PREVENT THIS PLAYER FROM CARRYING ANYONE", "
				if(global.isHost) {
					execute_string(carriers.sendBan, selectedPlayer, carriers.NetworkController.sendBuffer);
					execute_string(carriers.doBan, selectedPlayer);
				}
			");
		}
		// UNBAN
		if(global.isHost) {
			menu_addlink("UNBAN   - HOST -- Allow this player to carry anyone", "
				if(global.isHost) {
					execute_string(carriers.sendUnban, selectedPlayer, carriers.NetworkController.sendBuffer);
					execute_string(carriers.doUnban, selectedPlayer);
				}
			");
		}
	}

    menu_addback("Back", "
        instance_destroy();
        if(room == Options)
            room_goto_fix(Menu);
        else
            instance_create(0,0,InGameMenuController);
    ");
');

object_event_add(OptionMenu,ev_destroy,0,'
	with(carriers) {
		ini_open("gg2.ini");
		ini_write_real("Plugins","carriers_grabKey",grabKey);
		ini_write_real("Plugins","carriers_modeKey",modeKey);
		ini_write_real("Plugins","carriers_enable",carryEnable);
		ini_close();
		if(room != Options) {
			global.myself.carryEnable = carryEnable;
			// I KNOW NETWORKING HERE IS BAD BUT WHATEVER
			var enableByte;
			if(carryEnable)	enableByte = carriers.CARRY_ENABLE;
			else			enableByte = carriers.CARRY_DISABLE;
			if(global.isHost) {
				write_ubyte(carriers.NetworkController.sendBuffer, enableByte);
				write_ubyte(carriers.NetworkController.sendBuffer, ds_list_find_index(global.players, global.myself));
			} else {
				write_ubyte(carriers.NetworkController.sendBuffer, enableByte);
			}
		}
	}
');

object_event_add(OptionMenu,ev_draw,0,'
	event_inherited();
	var i, str;
	
	draw_set_halign(fa_left);
	draw_set_valign(fa_top);
	
	draw_set_alpha(0.5);
	draw_set_color(c_black);
	draw_rectangle(view_xview[0] + view_hview[0] - 100, view_yview[0] + 40,
		view_xview[0] + view_wview[0] - 10, view_yview[0] + view_hview[0] / 2 - 10, false);
		
	draw_set_alpha(1);
	draw_set_color(c_white);
	str = "Forbidden players:";
	for(i = 0; i < ds_list_size(global.myself.forbiddenCarriers); i+=1) {
		str += "#" + ds_list_find_value(global.myself.forbiddenCarriers, i).name;
	}
	draw_text(view_xview[0] + view_hview[0] - 96, view_yview[0] + 44, str);
		
	if(global.isHost) {
		draw_set_alpha(0.5);
		draw_set_color(c_black);
		draw_rectangle(view_xview[0] + view_hview[0] - 100, view_yview[0] + view_hview[0] / 2 + 10,
			view_xview[0] + view_wview[0] - 10, view_yview[0] + view_hview[0] - 40, false);
			
		draw_set_alpha(1);
		draw_set_color(c_white);
		str = "Banned players:";
		with(Player) {
			if(carryForbidden) {
				str += "#" + name;
			}
		}
		draw_text(view_xview[0] + view_hview[0] - 96, view_yview[0] + view_hview[0] / 2 + 14, str);
	}
');

object_event_add(InGameMenuController,ev_create,0,'
	menu_addlink("Carriers Options", "
		instance_destroy();
		instance_create(0,0,carriers.OptionMenu);
	");
');